<?php

declare(strict_types=1);

namespace App\Nova;

use Laravel\Nova\Fields\BelongsTo;
use Laravel\Nova\Fields\Boolean;
use Laravel\Nova\Fields\DateTime;
use Laravel\Nova\Fields\HasMany;
use Laravel\Nova\Fields\ID;
use Laravel\Nova\Fields\Number;
use Laravel\Nova\Fields\Text;
use Laravel\Nova\Fields\Textarea;
use Laravel\Nova\Http\Requests\NovaRequest;
use Maatwebsite\LaravelNovaExcel\Actions\DownloadExcel;

final class QuestionResource extends Resource
{
    /**
     * The model the resource corresponds to.
     *
     * @var class-string<\App\Models\Question>
     */
    public static string $model = \App\Models\Question::class;

    /**
     * The single value that should be used to represent the resource when being displayed.
     *
     * @var string
     */
    public static $title = 'text';

    /**
     * The columns that should be searched.
     *
     * @var array
     */
    public static $search = ['id', 'text'];

    /**
     * Indicates if the resource should be displayed in the sidebar.
     *
     * @var bool
     */
    public static $displayInNavigation = true;

    /**
     * The group associated with the resource.
     *
     * @var string
     */
    public static $group = 'Questionnaire';

    /**
     * Get the displayable label of the resource.
     */
    public static function label(): string
    {
        return 'Questions';
    }

    /**
     * Get the displayable singular label of the resource.
     */
    public static function singularLabel(): string
    {
        return 'Question';
    }

    /**
     * Get the fields displayed by the resource.
     *
     * @return array<int, \Laravel\Nova\Fields\Field|\Laravel\Nova\Panel|\Laravel\Nova\ResourceTool|\Illuminate\Http\Resources\MergeValue>
     */
    public function fields(NovaRequest $request): array
    {
        return [
            ID::make()->sortable(),

            BelongsTo::make('Question Group', 'questionGroup', QuestionGroupResource::class)
                ->sortable()
                ->filterable()
                ->readonly(),

            Textarea::make('Text')
                ->rules('required')
                ->updateRules('required'),

            Boolean::make('Has Yes')
                ->sortable()
                ->filterable()
                ->readonly(),

            Boolean::make('Has No')
                ->sortable()
                ->filterable()
                ->readonly(),

            Boolean::make('Has NA', 'has_na')
                ->sortable()
                ->filterable()
                ->readonly(),

            Text::make('Details')
                ->sortable()
                ->filterable()
                ->copyable()
                ->readonly(),

            Number::make('Sort Order')
                ->sortable()
                ->filterable()
                ->copyable()
                ->readonly(),

            Boolean::make('Is Scored')
                ->sortable()
                ->filterable()
                ->readonly(),

            DateTime::make('Created At')
                ->exceptOnForms()
                ->sortable()
                ->filterable(),

            DateTime::make('Updated At')
                ->exceptOnForms()
                ->sortable()
                ->filterable(),

            HasMany::make('Answers', 'answers', AnswerResource::class),
        ];
    }

    /**
     * Get the cards available for the request.
     *
     * @return array<int, \Laravel\Nova\Card>
     */
    public function cards(NovaRequest $request): array
    {
        return [];
    }

    /**
     * Get the filters available for the resource.
     *
     * @return array<int, \Laravel\Nova\Filters\Filter>
     */
    public function filters(NovaRequest $request): array
    {
        return [];
    }

    /**
     * Get the lenses available for the resource.
     *
     * @return array<int, \Laravel\Nova\Lenses\Lens>
     */
    public function lenses(NovaRequest $request): array
    {
        return [];
    }

    /**
     * Get the actions available for the resource.
     *
     * @return array<int, \Laravel\Nova\Actions\Action>
     */
    public function actions(NovaRequest $request): array
    {
        return [
            new DownloadExcel,
        ];
    }
}
